//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DarkGray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_level1  0
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern string TimeFrame           = "Current time frame";
extern double Length              = 14;
extern double Hot                 = 1.0;
extern int    Price               = PRICE_CLOSE;
extern bool   Original            = false;
extern bool   AlertsOn            = false;
extern bool   AlertsOnCurrent     = true;
extern bool   AlertsOnSlopeChange = true;
extern bool   AlertsOnLong        = true;
extern bool   AlertsOnShort       = true;
extern bool   AlertsOnZeroCross   = true;
extern bool   AlertsMessage       = true;
extern bool   AlertsSound         = false;
extern bool   AlertsEmail         = false;
extern bool   Interpolate         = true;
extern bool   ArrowsVisible       = false;
extern bool   ArrowsOnSlopeChange = true;
extern bool   ArrowsOnZeroCross   = true;
extern color  ArrowsZeroUpColor   = DeepSkyBlue;
extern color  ArrowsZeroDnColor   = PaleVioletRed;
extern color  ArrowsSlopeUpColor  = DeepSkyBlue;
extern color  ArrowsSlopeDnColor  = PaleVioletRed;
extern string ArrowsIdentifier    = "T3VelocityArrows";
extern double ArrowsZeroGap       = 0.75;
extern double ArrowsSlopeGap      = 1.00;

//
//
//
//
//

double vel[];
double velHuu[];
double velHud[];
double velHdd[];
double velHdu[];
double slope[];
double trend[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,velHuu); SetIndexStyle(0, DRAW_HISTOGRAM);
      SetIndexBuffer(1,velHud); SetIndexStyle(1, DRAW_HISTOGRAM);
      SetIndexBuffer(2,velHdd); SetIndexStyle(2, DRAW_HISTOGRAM);
      SetIndexBuffer(3,velHdu); SetIndexStyle(3, DRAW_HISTOGRAM);
      SetIndexBuffer(4,vel);
      SetIndexBuffer(5,slope);
      SetIndexBuffer(6,trend);
      
      //
      //
      //
      //
      //
   
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame == "returnBars");     if (returnBars)     return(0);
         calculateValue    = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);   

      //
      //
      //
      //
      //
   
      IndicatorDigits(5);
      IndicatorShortName(timeFrameToString(timeFrame)+" T3 velocity ("+DoubleToStr(Length,2)+","+DoubleToStr(Hot,2)+")");
   return(0);
}


//
//
//
//
//

int deinit()
{
   string lookFor       = ArrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { velHuu[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      {
         double price  = iMA(NULL,0,1,0,MODE_SMA,Price,i);
                vel[i] = iT3(price,Length,Hot,Original,i,0)-iT3(price,Length,Hot/2.0,Original,i,1);
             
                velHuu[i] = EMPTY_VALUE;
                velHud[i] = EMPTY_VALUE;
                velHdd[i] = EMPTY_VALUE;
                velHdu[i] = EMPTY_VALUE;
                trend[i]  = trend[i+1];
                slope[i]  = slope[i+1];
                  if (vel[i]>vel[i+1]) slope[i] =  1;
                  if (vel[i]<vel[i+1]) slope[i] = -1;
                  if (vel[i]>0)        trend[i] =  1;
                  if (vel[i]<0)        trend[i] = -1;
                  if (vel[i]>0)
                  if (slope[i]==1)
                        velHuu[i] = vel[i];
                  else  velHud[i] = vel[i];
                  if (vel[i]<0)
                  if (slope[i]==1)
                        velHdu[i] = vel[i];
                  else  velHdd[i] = vel[i];
               manageArrow(i);
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period())); 
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         vel[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Hot,Price,Original,AlertsOn,AlertsOnCurrent,AlertsOnZeroCross,AlertsOnSlopeChange,AlertsMessage,AlertsSound,AlertsEmail,Interpolate,ArrowsVisible,ArrowsOnSlopeChange,ArrowsOnZeroCross,ArrowsZeroUpColor,ArrowsZeroDnColor,ArrowsSlopeUpColor,ArrowsSlopeDnColor,ArrowsIdentifier,ArrowsZeroGap,ArrowsSlopeGap,4,y);
         velHuu[i] = EMPTY_VALUE;
         velHud[i] = EMPTY_VALUE;
         velHdd[i] = EMPTY_VALUE;
         velHdu[i] = EMPTY_VALUE;
         trend[i]  = trend[i+1];
         slope[i]  = slope[i+1];
             if (vel[i]>vel[i+1]) slope[i] =  1;
             if (vel[i]<vel[i+1]) slope[i] = -1;
             if (vel[i]>0)        trend[i] =  1;
             if (vel[i]<0)        trend[i] = -1;
             if (vel[i]>0)
         
         //
         //
         //
         //
         //

         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
               vel[i+k] = vel[i] + (vel[i+n] - vel[i])*k/n;
   }
   for(i=limit; i>=0; i--)
   {
      if (trend[i]>0)
         if (slope[i]==1)
               velHuu[i] = vel[i];
         else  velHud[i] = vel[i];
      if (trend[i]<0)
         if (slope[i]==1)
               velHdu[i] = vel[i];
         else  velHdd[i] = vel[i];
   }
   
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i)
{
   if (ArrowsVisible )
   {
         deleteArrow("z",Time[i]);
         if (ArrowsOnZeroCross && trend[i]!=trend[i+1])
         {
            if (trend[i] == 1) drawArrow("z",ArrowsZeroGap,i,ArrowsZeroUpColor,241,false);
            if (trend[i] ==-1) drawArrow("z",ArrowsZeroGap,i,ArrowsZeroDnColor,242,true);
         }
         deleteArrow("s",Time[i]);
         if (ArrowsOnSlopeChange && slope[i]!=slope[i+1])
         {
            if (slope[i] == 1) drawArrow("s",ArrowsSlopeGap,i,ArrowsSlopeUpColor,241,false);
            if (slope[i] ==-1) drawArrow("s",ArrowsSlopeGap,i,ArrowsSlopeDnColor,242,true);
         }
   }
}               

//
//
//
//
//

void drawArrow(string add, double tgap, int i,color theColor,int theCode,bool up)
{
   string name = ArrowsIdentifier+":"+add+Time[i];
   double gap  = tgap*iATR(NULL,0,20,i);
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrow(string add, datetime time)
{
   string lookFor = ArrowsIdentifier+":"+add+time; ObjectDelete(lookFor);
}
  
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (AlertsOn)
   {
      if (AlertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      
      //
      //
      //
      //
      //
      
      if (AlertsOnZeroCross && trend[whichBar] != trend[whichBar+1])
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (AlertsOnLong  && trend[whichBar] ==  1) doAlert(time1,mess1," T3 velocity crossed zero line up");
            if (AlertsOnShort && trend[whichBar] == -1) doAlert(time1,mess1," T3 velocity crossed zero line down");
      }
      if (AlertsOnSlopeChange && slope[whichBar] != slope[whichBar+1])
      {
         static datetime time2 = 0;
         static string   mess2 = "";
            if (AlertsOnLong  && slope[whichBar] ==  1) doAlert(time2,mess2," T3 velocity slope changed to up");
            if (AlertsOnShort && slope[whichBar] == -1) doAlert(time2,mess2," T3 velocity slope changed to down");
      }
   }
}


//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(Symbol()+" T3 velocity",message);
          if (AlertsSound)   PlaySound("alert2.wav");
   }
}
  
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][12];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}